/*
 * Test for the linear algebra of Normaliz 2.5
 * Copyright (C) 2010-2011 Christof Soeger
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdlib.h>
#include <vector>

#include<fstream>
#include <sstream>
using namespace std;

#include "libnormaliz/libnormaliz.h"
#include "libnormaliz/cone.h"
#include "libnormaliz/libnormaliz.cpp"
using namespace libnormaliz;


//---------------------------------------------------------------------------

int main(int argc, char* argv[]) {
    
    typedef long long I;

    libnormaliz::test_arithmetic_overflow = false;  //default: false
    
    ifstream fin("LAtest.in",ifstream::in);  // fits in long, 40s on old Mac
    int nr, nc;
    fin >> nr;
    fin >> nc;
    Matrix<I> M(15,15);
    I tmp;
                      
    for(int i=0; i<nr; i++) {
        for(int j=0; j<nc; j++) {
            fin >> tmp;
            M[i][j] = tmp;
        }
    }

    vector<I> diag(nr);
    I denom;
    Matrix<I> Result;

    for(int i=0; i< 100000; i++) {
        Result = M.invert(diag, denom);
    }

    return 0;
}
